//=======================================================================================
// removes all trace of objects that have %string as *PART* of their name
//=======================================================================================

function purgeNGSof (%string, %debug)
{
	%string=%string;
	%deleted=0;
	%objectsLeft=0;
    %ngs = nameToId(NamedGuiSet);
    %len = Group::objectCount(%ngs);
	if (%debug)
		{
		echo("***********************************************************************");
		echo("Number of Objects in Set: "@%len);
		echo ();
		}
    for(%i = 0; %i < %len; %i++)
	    {
	    %obj = Group::getObject(%ngs, %i);
		%objectName=Object::getName(%obj);
		if (%objectName=="") // There aren't any unnamed objects in the Named Gui Set
			{                // so something went wrong retrieving the object name
			if (%debug) echo ("Object: "@%i@" ("@%obj@") is an invalid object. Query on next pass");
			%objectsLeft++;
			}
		else if(Match::String (%objectName, "*"@%string@"*"))
		    {
			if (%debug) echo("Object: "@%i@" ("@%obj@") : "@%objectName@" - deleting");
			deleteObject(%obj);
			%deleted++;
		    }
		else if (%debug) echo("Object: "@%i@" ("@%obj@") : "@%objectName);
    	}

	//This is pedantic, but do you think I care ?
	if (%deleted==0)
		%numOfObjects="All requested objects deleted for "@%string@". ";
	else if (%deleted==1)
		%numOfObjects="Deleted a single object. ";
	else %numOfObjects="Deleted "@%deleted@" objects. ";

	if (%objectsLeft==0)
		%objectsLeftText="are no objects";
	else if (%objectsLeft==1)
		%objectsLeftText="is only one object";
	else %objectsLeftText="are "@%objectsLeft@" objects";

	if (%debug)
		echo();
	echo(%numOfObjects@"There "@%objectsLeftText@" left to query for "@%string@". ");
	if (%debug)
		echo("***********************************************************************");
	if (%objectsLeft!=0)
		purgeNGSof (%string);
	return;
}

function NGS::register (%str)
{
	$NGS::str[$NGS::registered]=%str;
	$NGS::registered++;
}

function NGS::clear ()
{
	for (%i=0;%i<$NGS::registered; %i++)
		purgeNGSof ($NGS::str[%i], false);
}

function NGS::playGuiOpen (%gui)
{
	if (%gui==playGui)
		if (!$MT::playGui::triggeredOnce)
			{
			NGS::clear ();
			$MT::playGui::triggeredOnce=true;
			}
}

function NGS::gameOver ()
{
	NGS::clear ();
}

$NGS::registered=0;

$MT::playGui::triggeredOnce=false;
event::attach (eventGuiOpen, NGS::playGuiOpen);
event::attach (eventExit, NGS::gameOver);
